#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: bubblesort.py (implementiert Sortieren durch Austausch) 
# W. Spiegel, 2004-03-17
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            


def bubbleSort(feld):
      """BubbleSort (Sortieren durch Austausch) nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 83/84   
      """
      verbose = 1 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(0,letztes-1):
            if verbose:
                  print "    i       Feld"

            for i in range(letztes-1,grenze,-1):                  
                  if (feld[i-1] > feld[i]):                        
                        feld[i],feld[i-1]= feld[i-1],feld[i] # tauschen
                  if verbose:
                        print ' '*3, i,
                        print ' >>> ',
                        printListe(feld)
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)
            
      
def test():
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      import string
      liste = genArray(7)      
      print "\n\nUnsortiertes Feld >>> ",
      printListe(liste)
      bubbleSort(liste)
      print "Fertig!! \nSortiertes Feld   >>> ",
      printListe(liste)
####################################
if __name__ == "__main__": # ausprobieren      
      test()

##Testlauf:
##Unsortiertes Feld >>>  29 55 21 34 17 7 5
##Grenze  Feld
##    i       Feld
##    6  >>>  29 55 21 34 17 5 7
##    5  >>>  29 55 21 34 5 17 7
##    4  >>>  29 55 21 5 34 17 7
##    3  >>>  29 55 5 21 34 17 7
##    2  >>>  29 5 55 21 34 17 7
##    1  >>>  5 29 55 21 34 17 7
##0  >>>  5 29 55 21 34 17 7
##    i       Feld
##    6  >>>  5 29 55 21 34 7 17
##    5  >>>  5 29 55 21 7 34 17
##    4  >>>  5 29 55 7 21 34 17
##    3  >>>  5 29 7 55 21 34 17
##    2  >>>  5 7 29 55 21 34 17
##1  >>>  5 7 29 55 21 34 17
##    i       Feld
##    6  >>>  5 7 29 55 21 17 34
##    5  >>>  5 7 29 55 17 21 34
##    4  >>>  5 7 29 17 55 21 34
##    3  >>>  5 7 17 29 55 21 34
##2  >>>  5 7 17 29 55 21 34
##    i       Feld
##    6  >>>  5 7 17 29 55 21 34
##    5  >>>  5 7 17 29 21 55 34
##    4  >>>  5 7 17 21 29 55 34
##3  >>>  5 7 17 21 29 55 34
##    i       Feld
##    6  >>>  5 7 17 21 29 34 55
##    5  >>>  5 7 17 21 29 34 55
##4  >>>  5 7 17 21 29 34 55
##    i       Feld
##    6  >>>  5 7 17 21 29 34 55
##5  >>>  5 7 17 21 29 34 55
##Fertig!! 
##Sortiertes Feld   >>>  5 7 17 21 29 34 55
