#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: liste.py 
# Einfach verkettete Liste
# W. Spiegel, 2004-04-01
# vgl. Data Structures and Algorithms in Java, pp 162ff
# fehlt: loeschen (delete), bfs, min, max
#################################  
class Knoten:
      """Class Knoten: Knoten fr Liste"""
      def __init__ (self, inhalt=None, next=None):
            self._inhalt_,self.next = inhalt, next

      def ausgabe(self):
            print str(self._inhalt_)
            
      def getInhalt(self):            
            return self._inhalt_
      
                      
                        

class linListe(Knoten):
      """Class LinListe: Eine lineare Liste besteht aus Knoten (!)"""
      def __init__ (self):
            self.first = None #= Knoten()
            self.last = None 
            
      def leer(self):
            return (self.first==None)

      def hole(self,wort):
            zeiger = self.first
            while (zeiger != None):
                  ##zeiger.ausgabe()
                  if wort == zeiger._inhalt_:
                        return 1                        
                  else:
                        zeiger = zeiger.next
            # Liste einmal OHNE Erfolg durch
            return 0
            
      def getInhalt(self):
            return self.first._inhalt_

      def getNext(self):
            return self.first.next

      def laenge(self):
            """gibt Laenge der Liste zurueck"""
            zeiger = self.first
            i = 0
            while (zeiger != None):
                  i = i + 1
                  zeiger = zeiger.next
            return i

            
      def druckeListe(self):
            """Druckt die Liste"""
            zeiger = self.first
            while (zeiger != None):
                  print zeiger.getInhalt(),
                  zeiger = zeiger.next
                  
      def amAnfang(self,wort):
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,                  
                  if (self.first != None):
                        print ", Knoten: ",
                        self.first.ausgabe()
                  else:
                        print
            neu = Knoten(wort)
            # am Anfang einfuegen
            if self.leer():
                  self.last = neu
            neu.next = self.first
            self.first = neu
      
      def haengeAn(self,wort):
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,                  
                  if (self.first != None):
                        print ", Knoten: ",
                        self.first.ausgabe()
                  else:
                        print
            neu = Knoten(wort)
            # am Ende anHaengen
            if self.leer():
                  self.first = neu
            else:
                  self.last.next = neu
            self.last = neu

            
      def einfuegen(self,wort):
            """baut Liste alphabetisch auf"""
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,                  
                  if (self.first != None):
                        print ", Knoten: ",
                        self.first.ausgabe()
                  else:
                        print
            neu = Knoten(wort)
            if self.leer():   # Liste ist leer
                  self.first = neu
                  self.last = neu
            else:
                  zeiger = self.first            
                  while ((zeiger != None) and (wort > zeiger.getInhalt())):                  
                        zeiger = zeiger.next
                  if _debug_ and (zeiger != None):                  
                        print "Position gefunden:",
                        zeiger.ausgabe()                        
                  if (zeiger == None):    # Einfuegen am Ende
                        self.last.next = neu
                        self.last = neu
                  else:
                        neu.next = zeiger.next  # Element einfuegen
                        zeiger.next = neu       # zeiger -> zeiger.next ==> zeiger -> zeiger.next -> neu
            


####################################
if __name__ == "__main__": # ausprobieren
      import string
      # Beispielsatz
      test_satz = "hallo wie gehts denn so?"
      test_li = string.split(test_satz)
      print '\nBeispielsatz:\n' + test_satz
      print test_li, '\n'      
      # Test der Klasse         
      liste1 = linListe()
      liste2 = linListe()
      liste3 = linListe()
      for wort in test_li:    # Liste aufbauen
            liste1.einfuegen(wort)
            liste3.haengeAn(wort)
            liste2.amAnfang(wort)
      # und ausgeben
      print "\nAusgabe Liste:"         
      liste1.druckeListe()
      print
      liste2.druckeListe()
      print
      liste3.druckeListe()
      print "\nLaenge:",liste2.laenge()            
      ## hole-Test
      print '\nhole-Test:',
      test =  'so?'     
      print '<' + test + '> ',
      if liste1.hole(test):
            print 'gefunden!!'
      else:
            print 'nicht gefunden!!'

##Testlauf:
##Beispielsatz:
##hallo wie gehts denn so?
##['hallo', 'wie', 'gehts', 'denn', 'so?'] 
##
##Ausgabe Liste:
##hallo denn gehts wie so?
##so? denn gehts wie hallo
##hallo wie gehts denn so? 
##Laenge: 5
##
##hole-Test: <so?>  gefunden!!
