#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: stack3.py 
# W. Spiegel, 2004-03-21
#################################                    
class Stack:
      """Class Stack: Kellerspeicher in Python"""
      def __init__ (self,inhalt=None):
            if inhalt:
                  self._stack_ = [inhalt]
            else:
                  self._stack_ = []
            
      
      def push(self,inhalt=None):
            if (inhalt == None):
                  return 0
            else:
                self._stack_.append(inhalt)
                return 1

      def pop(self):
            if not self.leer():
                  return self._stack_.pop()
            else:
                  return None
            
      def top(self):
            """gibt letztes Element aus"""
            if not self.leer():
                  return self._stack_[-1]
            else:
                  return None

      def leer(self):
            return (self._stack_ == [])

      def _printStack_(self):
            """Druckt den Stack"""
            if not self.leer():
                  for element in self._stack_:
                        print element,
            else:
                  print "Stack ist leer!"
            print

####################################
if __name__ == "__main__": # ausprobieren
      import string
      # Beispielsatz
      test_satz = "hallo wie gehts denn so?"
      test_li = string.split(test_satz)
      print '\n\n' + test_satz
      print test_li, '\n'      
      # Test der Klasse         
      myStack = Stack()
      print "Top of Stack: >",
      print myStack.top()

      print "\nBaue Stack auf . . ."
      for wort in test_li:    # Stack aufbauen
            myStack.push(wort)
      # und ausgeben
      print "\nAusgabe Stack:"         
      myStack._printStack_()

      print "Top of Stack: >",
      print myStack.top()
      print
      # Stack wieder popen!
      print "Stack popen:"
      inhalt = myStack.pop()
      i = 1
      while inhalt <> None:
            print " "*i,inhalt
            inhalt = myStack.pop()  # naechstes Element holen
            i = i + 1

##Testlauf:
##hallo wie gehts denn so?
##['hallo', 'wie', 'gehts', 'denn', 'so?'] 
##
##Top of Stack: > None
##            
##Baue Stack auf . . .
##
##Ausgabe Stack:
##hallo wie gehts denn so?
##Top of Stack: > so?
##
##Stack popen:
##  so?
##   denn
##    gehts
##     wie
##      hallo
